﻿using System;
using System.Collections.Generic;

namespace Understanding_Linq_2
{
    public class Projector<TSource, TTarget>  : IEnumerable<TTarget> where TSource : new()
    {
        public Projector(Filter<TSource> source, Func<TSource, TTarget> projection)
        {
            m_source = source;
            m_projection = projection;
        }

        Filter<TSource> m_source;
        Func<TSource, TTarget> m_projection;

        #region IEnumerable<TTarget> Members

        public IEnumerator<TTarget> GetEnumerator()
        {
            foreach (TSource current in m_source)
            {
                yield return m_projection(current);
            }
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        #endregion
    }
}
