﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.IO;

namespace Understanding_Linq_3
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class SimpleCsvService : System.Web.Services.WebService
    {
        [WebMethod]
        public string[][] GetCsvData(string csvFile, string columnList, string filter)
        {
            int[] columnsNeeded = Array.ConvertAll(columnList.Split(','), s => int.Parse(s));
            List<string[]> data = new List<string[]>();

            //load data from file
            using (StreamReader file = File.OpenText(base.Context.Request.MapPath("App_Data/"+csvFile)))
            {
                if (!file.EndOfStream) file.ReadLine();

                while (!file.EndOfStream)
                {
                    string line = file.ReadLine();
                    line = line.Trim();

                    if (line.Length > 0)
                    {
                        string[] parts = line.Split(';');
                        if ((string.IsNullOrEmpty(filter)) || (EvaluateFilter(filter, parts)))
                        {
                            string[] extract = new string[columnsNeeded.Length];
                            for (int targetIndex = 0; targetIndex < extract.Length; targetIndex++) extract[targetIndex] = parts[columnsNeeded[targetIndex]];
                            data.Add(extract);
                        }
                    }
                }
            }

            return data.ToArray();
        }

        private bool EvaluateFilter(string filter, string[] parts)
        {
            string[] filterparts = filter.Split(';');

            int filterColumn = int.Parse(filterparts[0]);
            string filterOperator = filterparts[1];
            string filterValue = filterparts[2];
            Type filterDataType = (filterparts.Length > 3) ? Type.GetType(filterparts[3])  : null;

            object left = parts[filterColumn];
            object right = filterValue;

            if (filterDataType != null)
            {
                left = Convert.ChangeType(left, filterDataType);
                right = Convert.ChangeType(right, filterDataType);
            }

            int compare = System.Collections.Comparer.DefaultInvariant.Compare(left, right);

            if (filterOperator == "==") return (compare == 0);
            if (filterOperator == "<") return (compare < 0);
            if (filterOperator == ">") return (compare > 0);

            return false;
        }
    }
}
